<?php define("_INSIDE",1);

require_once(realpath('./loader.inc.php'));
include_once(INC_PATH.'settings.inc.php');
include_once(INC_PATH.'functions.inc.php');
include_once(INC_PATH.'template.class.php');

$GLOBALS['_dnet']['prj'] = 'RC5-72';

if(is_array($_GET['c'])) {
	$GLOBALS['_dnet']['c'][0] = htmlspecialchars($_GET['c'][0]);
	$GLOBALS['_dnet']['c'][1] = htmlspecialchars($_GET['c'][1]);
	$GLOBALS['_dnet']['client'] = $GLOBALS['_dnet']['c'][0]."@".$GLOBALS['_dnet']['c'][1];
}
$GLOBALS['_dnet']['act_time'] = gmdate("U") - 86400; // set after functions.php - otherwise getting logfile of 2 days ago!!!

// start the template system for output
$tmpl = new Template(strtolower($GLOBALS['_dnet']['prj']).'.yesterday.tpl');
$tmpl->setContent('title', $GLOBALS['_dnet']['lang']['userstats'].' ('.$GLOBALS['_dnet']['prj'].') '.$GLOBALS['_dnet']['lang']['yesterday']);

$team_data = DNETLog::getData($GLOBALS['_dnet']['prj'], true);
if(!is_array($team_data) || count($team_data) <= 0 || empty($team_data['cl'][($GLOBALS['_dnet']['client'])])) {
	$tmpl->setTemplate('error.tpl');
	$tmpl->setContent('error', $GLOBALS['_dnet']['lang']['nolog']);
	echo $tmpl->Render();
	exit();
}

$tmpl->addHeaderScript('<script language="javascript" type="text/javascript">
  function popup(ip) { window.open("./hostname.php?ip="+ip+"&showlang='.$GLOBALS['_dnet']['web']['lang'].'","Hostname","width=400,height=300"); }
</script>');

$tmpl->setSubTemplate('UsersTableTemplate', 'clients.userstable.tpl');
$client_table_heads = array(
	'colNum' => '&nbsp;',
	'colClient' => $GLOBALS['_dnet']['lang']['client'],
	'colPackages' => $GLOBALS['_dnet']['lang']['packages'],
	'colPart' => $GLOBALS['_dnet']['lang']['part'],
	'colBlocks' => $GLOBALS['_dnet']['lang']['blocks']
	);
$tmpl->setContent($client_table_heads);

$clients = array();
$packpart = ($team_data['cl'][($GLOBALS['_dnet']['client'])]['sum']['packages']*100/$team_data['sum']['packages']);
$blockpart = ($team_data['cl'][($GLOBALS['_dnet']['client'])]['sum']['blocks']*100/$team_data['sum']['blocks']);
$clients[] = array(
	'num' => '&nbsp;',
	'client' => emailCloaking($GLOBALS['_dnet']['client'],false),
	'packages' => $team_data['cl'][($GLOBALS['_dnet']['client'])]['sum']['packages'],
	'packages_percentage' => number_format($packpart,2,',','.'),
	'packages_width_done' => round($packpart),
	'packages_width_todo' => (100-round($packpart)),
	'blocks' => $team_data['cl'][($GLOBALS['_dnet']['client'])]['sum']['blocks'],
	'blocks_percentage' => number_format($blockpart,2,',','.'),
	'blocks_width_done' => round($blockpart),
	'blocks_width_todo' => (100-round($blockpart))
	);
$tmpl->setContent('Clients', $clients);

$clients_contents = array(
	'Sum' => strtoupper($GLOBALS['_dnet']['lang']['teamall']),
	'SumPackages' => $team_data['sum']['packages'],
	'SumPackages_percentage' => '100,00',
	'SumPackages_width_done' => '100',
	'SumBlocks' => $team_data['sum']['blocks'],
	'SumBlocks_percentage' => '100,00',
	'SumBlocks_width_done' => '100',
	);
$tmpl->setContent($clients_contents);

/*
# Static parameters for the prediction / forecast:
# 1) One package (block) = 4'294'967'296 Keys
#    => out of the dnet RC5-72 statistics
#      (all-over keys / all-over blocks = static value)
# 2) One GHz CPU-Power = ca. 5'200'000 Keys/second
#    => measured with the dnet-client programm
#      (6 GHz CPU = 27'000'000 Keys/second +/- 12% => 6 GHz = ca. 31'000'000 Keys/second)
*/
// get timestamp client sent the first package today
$cl_update = split(" ",$team_data['cl'][($GLOBALS['_dnet']['client'])]['upd'][0]);
$cl_time = split(":",$cl_update[(count($cl_update)-1)]);
$day['active_start'] = gmmktime(intval($cl_time[0]),intval($cl_time[1]),intval($cl_time[2]),gmdate("m",$GLOBALS['_dnet']['act_time']),gmdate("d",$GLOBALS['_dnet']['act_time']),gmdate("Y",$GLOBALS['_dnet']['act_time']));
// get timestamp client sent the last package today
$cl_update = split(" ",$team_data['cl'][($GLOBALS['_dnet']['client'])]['upd'][1]);
$cl_time = split(":",$cl_update[(count($cl_update)-1)]);
$day['active_end'] = gmmktime(intval($cl_time[0]),intval($cl_time[1]),intval($cl_time[2]),gmdate("m",$GLOBALS['_dnet']['act_time']),gmdate("d",$GLOBALS['_dnet']['act_time']),gmdate("Y",$GLOBALS['_dnet']['act_time']));
// time of client-activity (must be min. of 1.0 hour to ensure realistic CPU-Power, Key-rate and day forecast)
$day['active_seconds'] = max(3600,($day['active_end'] - $day['active_start']));
$day['active_hours'] = $day['active_seconds'] / 3600;
// get other timestamps
$day['start'] = gmmktime(0,0,0,gmdate("m",$GLOBALS['_dnet']['act_time']),gmdate("d",$GLOBALS['_dnet']['act_time']),gmdate("Y",$GLOBALS['_dnet']['act_time']));
$day['end'] = gmmktime(23,59,59,gmdate("m",$GLOBALS['_dnet']['act_time']),gmdate("d",$GLOBALS['_dnet']['act_time']),gmdate("Y",$GLOBALS['_dnet']['act_time']));
// get packages per hour of run-time
$stat['packrate'] = ($team_data['cl'][($GLOBALS['_dnet']['client'])]['sum']['packages'] / $day['active_hours']);
$stat['blockrate'] = ($team_data['cl'][($GLOBALS['_dnet']['client'])]['sum']['blocks'] / $day['active_hours']);
$stat['blockpackrate'] = ($team_data['cl'][($GLOBALS['_dnet']['client'])]['sum']['blocks'] / $team_data['cl'][($GLOBALS['_dnet']['client'])]['sum']['packages']);
// get keyrate per second
// => transform: packages/hour into keys/second
// 1 Block    1hour          4'294'967'296 Keys    1 Block    4'294'967'296 Keys
// -------- * ------------ * ------------------ => -------- = ------------- ------
// 1 hour     3600 seconds   1 Block               1 hour     3600          second
//
// this means a factor of: 4'294'967'296 / 3600 = 1193046,47111...
// index: million keys/second => 1193046,471 / 1000000 => Multiplier: 1.193
$stat['keyrate'] = ($stat['blockrate'] * 1.193);
// get estimated cpu-power
// => keyrate / Power of 1 GHz CPU-Power
// index of keyrate is million keys/s => Multiplier: 5.2
$stat['cpupower'] = ($stat['keyrate'] / 5.2);

$stats_contents = array(
	'titleStatistics' => $GLOBALS['_dnet']['lang']['statistics'],
	'starttime' => $GLOBALS['_dnet']['lang']['starttime'],
	'starttimeValue' => gmdate($GLOBALS['_dnet']['lang']['dateformat'],($day['start']+$GLOBALS['_dnet']['act_offset'])),
	'endtime' => $GLOBALS['_dnet']['lang']['endtime'],
	'endtimeValue' => gmdate($GLOBALS['_dnet']['lang']['dateformat'],($day['end']+$GLOBALS['_dnet']['act_offset'])),
	'first_package' => $GLOBALS['_dnet']['lang']['first_package'],
	'first_packageValue' => gmdate($GLOBALS['_dnet']['lang']['dateformat'],($day['active_start']+$GLOBALS['_dnet']['act_offset'])),
	'last_package' => $GLOBALS['_dnet']['lang']['last_package'],
	'last_packageValue' => gmdate($GLOBALS['_dnet']['lang']['dateformat'],($day['active_end']+$GLOBALS['_dnet']['act_offset'])),
	'worktime' => $GLOBALS['_dnet']['lang']['worktime'],
	'worktimeValue' => gmdate("H",$day['active_seconds']).' '.$GLOBALS['_dnet']['lang']['h'].' '.gmdate("i",$day['active_seconds']).' '.$GLOBALS['_dnet']['lang']['m'].' '.gmdate("s",$day['active_seconds']).' '.$GLOBALS['_dnet']['lang']['s'],
	'packrate' => $GLOBALS['_dnet']['lang']['packrate'],
	'packrateValue' => number_format($stat['packrate'],2,',','.').' '.$GLOBALS['_dnet']['lang']['packrateindex'],
	'blockpackrate' => $GLOBALS['_dnet']['lang']['blockpackrate'],
	'blockpackrateValue' => number_format($stat['blockpackrate'],2,',','.').' '.$GLOBALS['_dnet']['lang']['blockpackrateindex'],
	'blockrate' => $GLOBALS['_dnet']['lang']['blockrate'],
	'blockrateValue' => number_format($stat['blockrate'],2,',','.').' '.$GLOBALS['_dnet']['lang']['blockrateindex'],
	'keyrate' => $GLOBALS['_dnet']['lang']['keyrate'],
	'keyrateValue' => number_format($stat['keyrate'],2,',','.').' '.$GLOBALS['_dnet']['lang']['keyrateindex'],
	'cpupower' => $GLOBALS['_dnet']['lang']['cpupower'],
	'cpupowerValue' => number_format($stat['cpupower'],2,',','.').' GHz'
	);
$tmpl->setContent($stats_contents);

// Userdetails:
// set up sub-template substitution for {#UserDetailsTemplate#}
// including all data in it.
require_once('./client.userdetails.php');

// Bar-Graph
$tmpl->setSubTemplate('GraphIframeTemplate', 'clients.graphs.iframe.tpl');
$bar_contents = array(
	'GraphTitle' => $GLOBALS['_dnet']['lang']['day_stats'],
	'frameName' => 'if_diagrams',
	'frameClass' => 'iframe_diagrams',
	'frameScrolling' => 'auto',
	'GraphURL' => 'graphs.frame.php?y=1&prj='.$GLOBALS['_dnet']['prj'].'&showlang='.$GLOBALS['_dnet']['showlang'].'&c[0]='.$GLOBALS['_dnet']['c'][0].'&c[1]='.$GLOBALS['_dnet']['c'][1],
	'GraphWidth' => $GLOBALS['_dnet']['web']['day_stats_iframe']['width'],
	'GraphHeight' => $GLOBALS['_dnet']['web']['day_stats_iframe']['height'],
	);
$tmpl->setContent($bar_contents);

echo $tmpl->Render();

?>