<?php if (!defined("_INSIDE")) die ("Restricted access!!!");
# This class is a helper to generate colored pie-charts.
# it is intented as feature-enhancement to the pie-chart script originally
# created by Rasmus - http://www.peters1.dk
#
# (c)2008 under GPL by Steffen Ille <steffen@steffen-ille.de>
#                  and Joerg Risse  <TheWayne@the-hall.info>

require_once(realpath('./loader.inc.php'));
include_once(INC_PATH.'settings.inc.php');
include_once(INC_PATH.'dyncolor.class.php');
include_once(INC_PATH.'functions.inc.php');

# -----------------------------------------------------------------------------------------
class PieChart {
  var $image;
  var $data;
  var $label;
  var $color_order;
  var $uniqueID;
  
  # -----------------------------------------------------------------------------------------
  # Constructor
  # $data						(array)			numbered array of all data
  # $label					(array)			array of strings for data-labels
  # $color_order    (bool)      true = ordered color, false = disordered color of slices
  #
  # setup all the data for ths pie-charts.
  # also sets unique identifier for this pie-chart.
  #
  function PieChart($data, $label, $color_order = true) {
    $this->_setup($data, $label, $color_order);
  }

  # -----------------------------------------------------------------------------------------
  # PHP 5 Constructors
//  function __construct() { $this->_setup("", "", true); }
  function __construct($data, $label, $color_order = true) { $this->_setup($data, $label, $color_order); }

  # -----------------------------------------------------------------------------------------
  # Destructor
  # If the image is already setup -> destroy it
  #
  function PieChartDestructor() {
    if (!empty($this->image)) @imageDestroy($this->image);
    $this->image = null;
  }

  # -----------------------------------------------------------------------------------------
  # PHP 5 Destructor
  function __destruct() { $this->PieChartDestructor(); }
  
  # -----------------------------------------------------------------------------------------
  # based on the pie-chart script originally created by Rasmus - http://www.peters1.dk
  #
  # OUTPUT:
  # Creates a new pie-chart image resource in this class.
  #
  function createImage() {
    if (count($this->data) <= 0 || count($this->label) <= 0 || count($this->data) != count($this->label)) { return false; }

    set_time_limit(60);
    $height = $GLOBALS['_dnet']['pie_chart']['width']/2;

    $data_sum = array_sum($this->data);
    $text_length = 0; // max. length of a label
    $d_arr = array();
    for ($i = 0; $i < count($this->label); $i++)
    { $num = round(($this->data[$i]/$data_sum)*100,1);
      if (intVal($num*10) > 0) {
        $d_arr['number'][] = number_format($num,1,',','.');
        $d_arr['data'][] = $this->data[$i];
        $d_arr['label'][] = $this->label[$i];
      } else { $d_arr['zero_label'][] = $this->label[$i]; }
      if (strlen($this->label[$i]) > $text_length) $text_length = strlen($this->label[$i]);
    }

    if (is_array($d_arr['label']))
    { $antal_label = count($d_arr['label']);
      if (!empty($d_arr['zero_label'])) $antal_label += count($d_arr['zero_label']);
      $xtra = (5+15*$antal_label)-($height+ceil($GLOBALS['_dnet']['pie_chart']['shadow_height']));
      if ($xtra > 0) $xtra_height = (5+15*$antal_label)-($height+ceil($GLOBALS['_dnet']['pie_chart']['shadow_height']));
      $xtra_width = 5;
      if ($GLOBALS['_dnet']['pie_chart']['show_label']) $xtra_width += 20;
      if ($GLOBALS['_dnet']['pie_chart']['show_percent']) $xtra_width += 45;
      if ($GLOBALS['_dnet']['pie_chart']['show_text']) $xtra_width += $text_length*8;
      if ($GLOBALS['_dnet']['pie_chart']['show_parts']) $xtra_width += 35;
    }

    $this->image = ImageCreateTrueColor($GLOBALS['_dnet']['pie_chart']['width']+$xtra_width, $height+ceil($GLOBALS['_dnet']['pie_chart']['shadow_height'])+$xtra_height);

    # allocate all colors for the image
    $background_color = $this->_colorHex($GLOBALS['_dnet']['pie_chart']['background_color']);
    if ($GLOBALS['_dnet']['pie_chart']['transparent_back']) { $background_color = ImageColorTransparent($this->image, $background_color); }
    $font_color = $this->_colorHex($GLOBALS['_dnet']['pie_chart']['text_color']);
    $pie_splitter = 0;
    if ($GLOBALS['_dnet']['pie_chart']['background_color'] == $GLOBALS['_dnet']['pie_chart']['pie_split_color']) { $pie_splitter = $background_color; }
    elseif ($GLOBALS['_dnet']['pie_chart']['text_color'] == $GLOBALS['_dnet']['pie_chart']['pie_split_color']) { $pie_splitter = $font_color; }
    else {
      $pie_splitter = $this->_colorHex($GLOBALS['_dnet']['pie_chart']['pie_split_color']);
      if ($pie_splitter == 0 ) {
        $pie_col = DynColor::hex2rgb($GLOBALS['_dnet']['pie_chart']['pie_split_color']);
        $pie_splitter = imagecolorclosest($this->image,$pie_col['r'],$pie_col['g'],$pie_col['b']);
      }
    }

    $data_count = count($d_arr['label']) + ((isset($d_arr['zero_label']))?count($d_arr['zero_label']):0);
    $colors = array();
    if ($this->color_order) { $colors = DynColor::getColors($data_count, $GLOBALS['_dnet']['pie_chart']['grey_tones'], $GLOBALS['_dnet']['pie_chart']['grey_only']); }
    else { $colors = DynColor::getRandomColors($data_count, $GLOBALS['_dnet']['pie_chart']['grey_tones'], $GLOBALS['_dnet']['pie_chart']['grey_only']); }
    foreach ($colors as $k=>$color_arr)
    { $fill_color[] = $this->_colorHex($color_arr);
      $shadow_color[] = $this->_colorHexshadow($color_arr, $GLOBALS['_dnet']['pie_chart']['shadow_dark']);
    }

    # ILLE says:
    # Keine Ahnung... das folgende sollte funktionieren, tut es aber nicht...
    # Wenn Parameter der Zeit angegeben sind haut das Fill nicht hin. Sonst ja.
    # Ist aber Bldsinn... Das Linux sagt mit "php --rf imagefill" dass der folgende Aufruf vllig korrekt ist
    # und wie gesagt - ohne die Parameter in der URL klappt das ja auch.
    # Ein quick & dirty Hack ist ein Rechteck mit der Farbe zu nehmen auf voller Gre des Bildes *grml*
    # ImageFill($this->image, 0, 0, $this->_colorHex($GLOBALS['_dnet']['pie_chart']['background_color']));
    # QDH replaced:
    @imagefilledrectangle($this->image,0,0,$GLOBALS['_dnet']['pie_chart']['width']+$xtra_width,$height+ceil($GLOBALS['_dnet']['pie_chart']['shadow_height'])+$xtra_height,$background_color);

    $label_place = 5;

    # append labels with 0.0% to normal label-array for drawing
    if (isset($d_arr['zero_label'])) {
      for($i=0;$i < count($d_arr['zero_label']);$i++) {
        $d_arr['label'][] = $d_arr['zero_label'][$i];
        $d_arr['number'][] = "0.0";
      }
    }

    # draw labels and legend
    if (is_array($d_arr['label']))
    { for ($i = 0; $i < count($d_arr['label']); $i++)
      { $dataset = (isset($d_arr['data'][$i])) ? $d_arr['data'][$i] : $this->data[$i];
        if ($GLOBALS['_dnet']['pie_chart']['label_form'] == 'round' && $GLOBALS['_dnet']['pie_chart']['show_label'])
      	{ @imagefilledellipse($this->image,$GLOBALS['_dnet']['pie_chart']['width']+11,$label_place+5,10,10,$fill_color[$i % count($fill_color)]);
      	  @imageellipse($this->image,$GLOBALS['_dnet']['pie_chart']['width']+11,$label_place+5,10,10,$font_color);
      	}
      	elseif($GLOBALS['_dnet']['pie_chart']['label_form'] == 'square' && $GLOBALS['_dnet']['pie_chart']['show_label'])
      	{ @imagefilledrectangle($this->image,$GLOBALS['_dnet']['pie_chart']['width']+6,$label_place,$GLOBALS['_dnet']['pie_chart']['width']+16,$label_place+10,$fill_color[$i % count($fill_color)]);
      	  @imagerectangle($this->image,$GLOBALS['_dnet']['pie_chart']['width']+6,$label_place,$GLOBALS['_dnet']['pie_chart']['width']+16,$label_place+10,$font_color);
      	}
      	if ($GLOBALS['_dnet']['pie_chart']['show_percent']) {
          if ($dataset/$data_sum < 0.1) $label_output .= ' '.$d_arr['number'][$i].'% ';
          else $label_output .= $d_arr['number'][$i].'% ';
      	}
      	if ($GLOBALS['_dnet']['pie_chart']['show_text']) $label_output .= $d_arr['label'][$i].' ';
      	if ($GLOBALS['_dnet']['pie_chart']['show_parts']) $label_output .= $dataset;
      	imagestring($this->image,'2',$GLOBALS['_dnet']['pie_chart']['width']+20,$label_place,$label_output,$font_color);
      	$label_output = '';
      	$label_place = $label_place + 15;
      }
    }

    $centerX = round($GLOBALS['_dnet']['pie_chart']['width']/2);
    $centerY = round($height/2);
    $diameterX = $GLOBALS['_dnet']['pie_chart']['width']-4;
    $diameterY = $height-4;
    $start = 270;

    # calculate the slices of the pie
    for ($i = 0; $i < count($d_arr['data']); $i++)
    { $value += $d_arr['data'][$i];
      $end = ceil(($value/$data_sum)*360)+270;
      if ($start != $end) {
        $slice[] = array($start,$end,$shadow_color[$value_counter % count($shadow_color)],$fill_color[$value_counter % count($fill_color)]);
        $start = $end;
      }
      $value_counter++;
    }

    # draw pie slices
    for ($i=$centerY+$GLOBALS['_dnet']['pie_chart']['shadow_height'];$i>$centerY;$i--)
    { for ($j=0;$j<count($slice);$j++)
      { @imagefilledarc($this->image,$centerX,$i,$diameterX,$diameterY,$slice[$j][0],$slice[$j][1],$slice[$j][2],IMG_ARC_PIE); }
    }

    for ($j=0;$j<count($slice);$j++)
    { @imagefilledarc($this->image,$centerX,$centerY,$diameterX,$diameterY,$slice[$j][0],$slice[$j][1],$slice[$j][3],IMG_ARC_PIE);
      if (strlen($GLOBALS['_dnet']['pie_chart']['pie_split_color']) == 6) @imagefilledarc($this->image,$centerX,$centerY,$diameterX,$diameterY,$slice[$j][0],$slice[$j][1],$pie_splitter,IMG_ARC_PIE|IMG_ARC_NOFILL|IMG_ARC_EDGED);
    }
    unset($d_arr);
    return true;
  }

  # -----------------------------------------------------------------------------------------
  # PARAMETERS:
  # $cachefilename	(string)		name of the cache-file to be store in the image.
  #
  # Stores the image of the pie chart into a file
  # write it into $cachefilename as PNG-file.
  #
  # RETURNS the filename to where the image was stored. Otherwise false is returned.
  #
  function write2File($cachefilename) {
    if (empty($this->image)) return false;

    if (empty($cachefilename) || is_file($cachefilename)) { return false; }

    # write into $cachefilename, which is a filename with a relative path
    # the cachefilename can contain a __UNIQUE_ID__ wildcard, to be replaced
    # by the uniqueID of this pie-chart
    $cachefilename = str_replace("__UNIQUE_ID__",$this->uniqueID,$cachefilename);

    @imagePNG($this->image,$cachefilename);

    return $cachefilename;
  }

  # -----------------------------------------------------------------------------------------
  # PARAMETERS:
  # $cachefilename	(string)		name of the cache-file to be store in the image.
  #
  # Stores the image of the pie chart into a file
  # if the class Cache is available -> write it using the cache-class
  # else (if no cache class there) write directly into $cachefilename.
  #
  # RETURNS the filename to where the image was stored. Otherwise false is returned.
  #
  function write2CacheFile($prj, $yesterday) {
    if (empty($this->image) || !class_exists("Cache")) return false;

    return Cache::writeImage2PNG($this->image, $prj, $this->uniqueID, $yesterday);
  }

  # -----------------------------------------------------------------------------------------
  # PARAMETERS:
  # $data					(array/string)			data-array of % per dataset OR string splitted by *
  # $label				(array/string)			array of labelstrings OR string splitted by *
  #
  # OUTPUT:
  # Creates a unique identifer, which can be used as part of the cache-filename.
  # The unique part of the filename contains the percentage of each pie segment and
  # the labels, because the labels are language specific and its possible that all clients
  # produce the same pie chart in one category. i.e. all Clients using only x86 CPUs, so
  # we only need 1 cached pie chart for all of them, which shows the label with a pie
  # segment of 100%.
  #
  function getUniqueId($data, $label) {
    if (empty($data)) { $data = array(rand(100000,99999999)); }
    elseif(!is_array($data)) {
      $data = explode("*",$data);
      $data_sum = array_sum($data);
      for($i=0;$i<count($data);$i++) { $data[$i] = ($data[$i]/$data_sum)*100; }
    }
    if (empty($label)) { $label = array(rand(100000,99999999)); }
    elseif(!is_array($label)) { $label = explode("*",$label); }
    return md5("pie-".md5(implode("*",$data))."-".md5(implode("*",$label)));
  }

  # -----------------------------------------------------------------------------------------
  # Private Class-Functions
  # -----------------------------------------------------------------------------------------

  function _setup($data, $label, $color_order) {
    if (!empty($this->image)) @imageDestroy($this->image);;
    $this->image = null;

    $this->color_order = $color_order;

    if (empty($data)) { $this->data = array(rand(100000,99999999)); }
    elseif(!is_array($data)) {
      $data = explode("*",$data);
      $data_sum = array_sum($data);
      for($i=0;$i<count($data);$i++) { $this->data[$i] = ($data[$i]/$data_sum)*100; }
    }

    if (empty($label)) { $this->label = array(rand(100000,99999999)); }
    elseif(!is_array($label)) { $this->label = explode("*",$label); }

    $this->uniqueID = $this->getUniqueId($this->data,$this->label);
  }

  # -----------------------------------------------------------------------------------------
  #
  # PARAMETERS:
  # $this->image		(integer)				number of an image created using imagecreate functions
  # $color	(array/string) 	r-g-b array or hex-string of the color to be allocated
  #
  # based on the pie-chart script originally created by Rasmus - http://www.peters1.dk
  #
  # OUTPUT:
  # identifier (number) of the color in the image color-table OR 0 (error).
  #
  function _colorHex($color) {
    if (!is_array($color)) { $color = DynColor::hex2rgb($color); }
    if (count($color) != 3 || empty($this->image)) { return 0; }

    return ImageColorAllocate($this->image,$color['r'],$color['g'],$color['b']);
  }

  # -----------------------------------------------------------------------------------------
  # PARAMETERS:
  # $this->image		(integer)				number of an image created using imagecreate functions
  # $color	(array/string) 	r-g-b array or hex-string of the light color to be allocated
  # $mork		(boolean)				true = make dark shadow, false = make lighter shadow
  #
  # based on the pie-chart script originally created by Rasmus - http://www.peters1.dk
  #
  # OUTPUT:
  # identifier (number) of the shadow-color in the image color-table OR 0 (error).
  #
  function _colorHexShadow($color, $mork = false) {
    if (!is_array($color)) { $color = DynColor::hex2rgb($color); }
    if (count($color) != 3 || empty($this->image)) { return 0; }

    if ($mork)
    { ($color['r'] > 99) ? $color['r'] -= 100 : $color['r'] = 0;
  	($color['g'] > 99) ? $color['g'] -= 100 : $color['g'] = 0;
  	($color['b'] > 99) ? $color['b'] -= 100 : $color['b'] = 0;
    }
    else
    { ($color['r'] < 220) ? $color['r'] += 35 : $color['r'] = 255;
  	($color['g'] < 220) ? $color['g'] += 35 : $color['g'] = 255;
  	($color['b'] < 220) ? $color['b'] += 35 : $color['b'] = 255;
    }

    return @ImageColorAllocate($this->image,$color['r'],$color['g'],$color['b']);
  }

} # end: class PieChart

?>