<?php require_once(realpath('./loader.inc.php'));
#################
# CONFIGURATION #
#################

$web['log_path']    = '/usr/local/bin/dnet-proxy/';           # path to where the logfiles are
$web['this_page']   = 'http://dnet.the-hall.info/test/';           # Domain/Path to this Dnet-Livestats-Page
$web['team']        = 'The-Hall e.V.';                        # name of the user / team
$web['teamurl']     = 'www.the-hall.info';                    # URL of the team homepage
$web['contact']     = 'dnet@the-hall.info';                   # e-mail address for team-contact
$web['teamnr']      = 31716;                                  # dnet's team number
$web['logo']        = 'images/logos/the-hall.gif';            # image of your team logo
$web['favicon']     = 'images/dnet.ico';                      # favicon of the page
$web['lang']        = 'de';                                   # displayed language currently [ de | en ]
$web['timezone']    = +1;                                     # your timezone +/- UTC/GMT
$web['summertime']  = true;                                   # BOOLEAN - true: summer-/winter-time is active
$web['refresh']     = 0;                                      # page refresh frequency in seconds
$web['header_height']= 90;                                    # height (pixel) of the header frame (contains your team logo)
$web['navi_width']   = 100;                                   # width (pixel) of the navigation frame
$web['excluded_ids'] = array();                               # dnet-ids to be excluded from team-stats display
$web['template_path']= 'templates';                           # sub-folder where the template files for the page are

# the verify code for Google to index the page. If not empty: it's included as meta tag "verify-v1".
$web['google_verify'] = '7bh2/MDqWhWqS4r0nEqRIP4E9xQvQ9ESkb5BCaqORrw=';

$web['cache']['path']               = "./cache/";             # relative path to where the caching files are stored
$web['cache']['time']['std']        = 60;                     # seconds to cache data (standard value - not specialized)
$web['cache']['time']['pie_hours']  = 60;                     # seconds to cache the pie-chart (hours of the day)
$web['cache']['time']['pie_ip']     = 60;                     # seconds to cache the pie-chart (ip addresses)
$web['cache']['time']['pie_cpu']    = 3600;                   # seconds to cache the pie-chart (cpu-type)
$web['cache']['time']['pie_os']     = 900;                    # seconds to cache the pie-chart (operating systems)
$web['cache']['time']['pie_ver']    = 900;                    # seconds to cache the pie-chart (dnet-clinet version numbers)
$web['cache']['time']['pie_core']   = 900;                    # seconds to cache the pie-chart (dnet-client core versions)

$web['day_stats_iframe']['width']       = 900;  # width of the iframe for bar graphs and pie charts
$web['day_stats_iframe']['height']      = 400;  # height of the iframe for bar graphs and pie charts
$web['day_stats_iframe']['nav_height']  = 90;   # height of the navigation for the different charts and graphs
$web['day_stats_iframe']['nav_buffer']  = 20;   # pixel-# a embedded iframe is smaller, to avoid scrollbars in parent iframe

# BAR GRAPH CONFIGURATION
$bar_graph['height']        = 250;  # height of the bar graphs
$bar_graph['block_width']   = 10;   # width of a bar in the bar graph
$bar_graph['space_width']   = 5;    # width of the space between 2 blocks (bars) in the bar graph
$bar_graph['legend_width']  = 150;  # width of the legend of a bar graph

# dnet-projects to be shown in navigation with team links
$project['RC5-72']['id']        = 8;
$project['RC5-72']['log']       = 'pproxy.rc5-72.__ACT_UTC_Ymd__.log';
$project['RC5-72']['teampage']  = "team.rc5-72.php";
$project['RC5-72']['yesterday'] = "team.yesterday.rc5-72.php";
$project['RC5-72']['yesterday_log'] = "pproxy.rc5-72.__ACT_UTC_Ymd__.log";
$project['OGR-NG']['id']        = 26;
//$project['OGR-NG']['log']       = $web['log_path'].'pproxy.ogr-p2.__ACT_UTC_Ymd__.log';
//$project['OGR-NG']['teampage']  = "team.ogr-p2.php";
//$project['OGR-NG']['yesterday'] = "yesterday.ogr-p2.php";

# PIE CHART CONFIGURATION
$pie_chart['enabled']           = true;         # true = generate pie charts (GD2 Version 1.6 or higher needed)
$pie_chart['show_label']        = true;         # true = show label, false = don't show label.
$pie_chart['show_percent']      = true;         # true = show percentage, false = don't show percentage.
$pie_chart['show_text']         = true;         # true = show text, false = don't show text.
$pie_chart['show_parts']        = false;        # true = show parts, false = don't show parts.
$pie_chart['label_form']        = 'square';     # 'square' or 'round' label.
$pie_chart['width']             = 500;          # max width of the pie chart
$pie_chart['text_color']        = '000000';     # text-color.
$pie_chart['background_color']  = 'FFFFFF';     # background-color of the chart...
$pie_chart['transparent_back']  = true;         # true = define 'background_color' as transparent color...
$pie_chart['pie_split_color']   = '000000';     # edge-color to split the colored parts of the pie-chart
$pie_chart['grey_tones']        = false;        # use grey-tone colors for elements of the pie charts
$pie_chart['grey_only']         = false;        # use ONLY grey-tone colors for elements of the pie charts
$pie_chart['shadow_height']     = 16;           # Height of shadows.
$pie_chart['shadow_dark']       = true;         # true = darker shadow, false = lighter shadow...

###############################################
# DNET CONSTANTS & LANGUAGES (NO EDIT NEEDED) #
###############################################

$GLOBALS['_dnet']['web'] = $web;
$GLOBALS['_dnet']['bar_graph'] = $bar_graph;
$GLOBALS['_dnet']['project'] = $project;
$GLOBALS['_dnet']['pie_chart'] = $pie_chart;

include_once(INC_PATH.'constants.inc.php');
include_once(SRC_PATH.'languages'.DS.'langs.inc.php');
if (!defined("_INSIDE")) die ("Restricted access!!!");

?>