<?php define("_INSIDE",1);
require_once(realpath('./loader.inc.php'));
include_once(INC_PATH.'settings.inc.php');
include_once(INC_PATH.'functions.inc.php');
include_once(INC_PATH.'template.class.php');

@header('Cache-Control: private, no-cache, must-revalidate, post-check=0, pre-check=0');
@header('Pragma: private, no-cache');

# GENERATE DEFAULT VALUES FOR THE FIRST PAGE-VIEW
if($_POST['submit']=='')
{ $_POST['email']='';
  $_POST['ini_restart']='no';
  $_POST['pause_battery']='yes';
  $_POST['detached_mode']='no';
  $_POST['work_prio']='RC5-72,OGR-P2';
  $_POST['work_treshold']='10';
  $_POST['key_server_name']='the-hall.info';
  $_POST['key_server_port']='2064';
  $_POST['key_server_fallback']='yes';
  $_POST['crunchers']='-1';
}

# PROCESS DATA AFTER SUBMITTING THE FORMULAR
$ini_daten = '';
if($_POST['submit']==$GLOBALS['_dnet']['lang']['ic_submit'])
{ # ERROR DETECTION FOR THE WHOLE INPUT
  foreach($_POST as $i=>$v){ $_POST[$i]=trim(strip_tags(stripslashes($v))); }
  if(!eregi("^([a-z0-9_]|\\-|\\.)+@(([a-z0-9_]|\\-)+\\.)+[a-z]{2,4}$",$_POST['email']))  { $errmsg=$GLOBALS['_dnet']['lang']['ic_err_mail']; }
  elseif($_POST['work_treshold']=='0' || !eregi("^[0-9]{1,3}$",$_POST['work_treshold'])) { $errmsg=$GLOBALS['_dnet']['lang']['ic_err_pkgs']; }
  elseif($_POST['key_server_name']!='' && !eregi("^(([a-z0-9_]|\\-)+\\.)+[a-z]{2,4}$",$_POST['key_server_name']) && ip_check($_POST['key_server_name'])=="false")
  { $errmsg=$GLOBALS['_dnet']['lang']['ic_err_host']; }
  elseif($_POST['key_server_port']!='' && !eregi("^([1-9]{1})+([0-9]{0,4})$",$_POST['key_server_port'])) { $errmsg=$GLOBALS['_dnet']['lang']['ic_err_port']; }
  elseif (($_POST['key_server_port']!='' && $_POST['key_server_name']=='') || ($_POST['key_server_port']=='' && $_POST['key_server_name']!=''))
  { $errmsg=$GLOBALS['_dnet']['lang']['ic_err_hopo']; }

  # IF DATA IS OK THEN GENERATE THE DNETC.INI FILE WITH THOSE SETTINGS
  if($errmsg=='')
  { if($_POST['key_server_name']=='' && $_POST['key_server_port']=='')
    { $key_server_autofind="yes"; } else { $key_server_autofind="no"; }
    # elseif($_POST['key_server_fallback']=='true'){ $key_server_autofind="yes"; }
    # elseif($_POST['key_server_fallback']=='false'){ $key_server_autofind="no"; }
    $ini_daten ="[parameters]\n";
    $ini_daten.="id=".$_POST['email']."\n";
    $ini_daten.="\n";
    $ini_daten.="[triggers]\n";
    $ini_daten.="restart-on-config-file-change=".$_POST['ini_restart']."\n";
    $ini_daten.="pause-on-no-mains-power=".$_POST['pause_battery']."\n";
    $ini_daten.="\n";
    $ini_daten.="[display]\n";
    $ini_daten.="progress-indicator=auto-sense\n";
    $ini_daten.="detached=".$_POST['detached_mode']."\n";
    $ini_daten.="\n";
    $ini_daten.="[buffers]\n";
    $ini_daten.="frequent-threshold-checks=4\n";
    $ini_daten.="\n";
    $ini_daten.="[misc]\n";
    $ini_daten.="project-priority=".$_POST['work_prio']."\n";
    $ini_daten.="\n";
    $ini_daten.="[processor-usage]\n";
    $ini_daten.="max-threads=".$_POST['threads']."\n";
    $ini_daten.="priority=".$_POST['cpuprio']."\n";
    $ini_daten.="\n";
    $ini_daten.="[rc5-72]\n";
    $ini_daten.="fetch-workunit-threshold=".$_POST['work_treshold']."\n";
    $ini_daten.="core=-1\n";
    $ini_daten.="\n";
    $ini_daten.="[ogr-ng]\n";
    $ini_daten.="fetch-workunit-threshold=".$_POST['work_treshold']."\n";
    $ini_daten.="core=-1\n";
    $ini_daten.="\n";
    $ini_daten.="[networking]\n";
    $ini_daten.="autofindkeyserver=".$key_server_autofind."\n";
    $ini_daten.="nofallback=".$_POST['key_server_fallback']."\n";
    if($key_server_autofind=="no")
    { $ini_daten.="keyserver=*:".$_POST['key_server_port'].";".$_POST['key_server_name']."\n"; }
} }

$form_data = array(
  "FormAction" => $_SERVER['PHP_SELF'].'?showlang='.$GLOBALS['_dnet']['showlang'],
  "Yes" => $GLOBALS['_dnet']['lang']['ic_sel_yes'],
  "No" => $GLOBALS['_dnet']['lang']['ic_sel_no'],
  "FormEmail" => $GLOBALS['_dnet']['lang']['ic_tbl_mail'].' (Client-ID)',
  "FormIni" => $GLOBALS['_dnet']['lang']['ic_tbl_ini'],
  "FormIniYes" => (($_POST['ini_restart']=='yes') ? ' selected="selected"' : '' ),
  "FormIniNo" => (($_POST['ini_restart']=='no') ? ' selected="selected"' : '' ),
  "FormBattery" => $GLOBALS['_dnet']['lang']['ic_tbl_batt'],
  "FormBatteryYes" => (($_POST['pause_battery']=='yes') ? ' selected="selected"' : '' ),
  "FormBatteryNo" => (($_POST['pause_battery']=='no') ? ' selected="selected"' : '' ),
  "FormDetached" => $GLOBALS['_dnet']['lang']['ic_tbl_quiet'],
  "FormDetachedYes" => (($_POST['detached_mode']=='yes') ? ' selected="selected"' : '' ),
  "FormDetachedNo" => (($_POST['detached_mode']=='no') ? ' selected="selected"' : '' ),
  "FormPrio" => $GLOBALS['_dnet']['lang']['ic_tbl_prio'],
  "FormPrioRConly" => (($_POST['work_prio']=='RC5-72,OGR-NG=0') ? ' selected="selected"' : '' ),
  "FormPrioOGRonly" => (($_POST['work_prio']=='OGR-NG,RC5-72=0') ? ' selected="selected"' : '' ),
  "FormPrioRCfirst" => (($_POST['work_prio']=='RC5-72,OGR-NG') ? ' selected="selected"' : '' ),
  "FormPrioOGRfirst" => (($_POST['work_prio']=='OGR-NG,RC5-72') ? ' selected="selected"' : '' ),
  "FormTreshold" => $GLOBALS['_dnet']['lang']['ic_tbl_pkgs'],
  "FormServer" => $GLOBALS['_dnet']['lang']['ic_tbl_host'],
  "FormServerPort" => $GLOBALS['_dnet']['lang']['ic_tbl_port'],
  "FormServerFallback" => $GLOBALS['_dnet']['lang']['ic_tbl_fallb'],
  "FormServerFallbackYes" => (($_POST['key_server_fallback']=='true') ? ' selected="selected"' : '' ),
  "FormServerFallbackNo" => (($_POST['key_server_fallback']=='false') ? ' selected="selected"' : '' ),
  "FormThreads" => $GLOBALS['_dnet']['lang']['ic_tbl_cmax'],
  "FormThreadsAuto" => (($_POST['threads']=='-1') ? ' selected="selected"' : '' ),
  "FormThreads1" => (($_POST['threads']=='1') ? ' selected="selected"' : '' ),
  "FormThreads2" => (($_POST['threads']=='2') ? ' selected="selected"' : '' ),
  "FormThreads4" => (($_POST['threads']=='4') ? ' selected="selected"' : '' ),
  "FormThreads6" => (($_POST['threads']=='6') ? ' selected="selected"' : '' ),
  "FormThreads8" => (($_POST['threads']=='8') ? ' selected="selected"' : '' ),
  "FormThreads12" => (($_POST['threads']=='12') ? ' selected="selected"' : '' ),
  "FormThreads16" => (($_POST['threads']=='16') ? ' selected="selected"' : '' ),
  "FormCPUPrio" => $GLOBALS['_dnet']['lang']['ic_tbl_cycl'],
  "FormCPUPrio0" => (($_POST['cpuprio']=='0') ? ' selected="selected"' : '' ),
  "FormCPUPrio1" => (($_POST['cpuprio']=='1') ? ' selected="selected"' : '' ),
  "FormCPUPrio2" => (($_POST['cpuprio']=='2') ? ' selected="selected"' : '' ),
  "FormCPUPrio3" => (($_POST['cpuprio']=='3') ? ' selected="selected"' : '' ),
  "FormCPUPrio4" => (($_POST['cpuprio']=='4') ? ' selected="selected"' : '' ),
  "FormCPUPrio5" => (($_POST['cpuprio']=='5') ? ' selected="selected"' : '' ),
  "FormCPUPrio6" => (($_POST['cpuprio']=='6') ? ' selected="selected"' : '' ),
  "FormCPUPrio7" => (($_POST['cpuprio']=='7') ? ' selected="selected"' : '' ),
  "FormCPUPrio8" => (($_POST['cpuprio']=='8') ? ' selected="selected"' : '' ),
  "FormCPUPrio9" => (($_POST['cpuprio']=='9') ? ' selected="selected"' : '' ),
  "FormHint" => $GLOBALS['_dnet']['lang']['ic_tbl_hint'],
  "FormError" => $errmsg,
  "FormSubmit" => $GLOBALS['_dnet']['lang']['ic_submit']
);

$tmpl = new Template('inicreator.tpl');
$tmpl->setContent("Headline", $GLOBALS['_dnet']['lang']['ic_head']);
$tmpl->setContent("TableHeadline", $GLOBALS['_dnet']['lang']['ic_tbl_head']);
$tmpl->setContent($_POST);
$tmpl->setContent($form_data);
if ($ini_daten!='') {
	$tmpl->setContent("IniDaten", array( array(
		"CopyHint" => $GLOBALS['_dnet']['lang']['ic_cpy_hint'],
		"IniData" => $ini_daten
		) ) );
} else { $tmpl->setContent("IniDaten", array()); }

echo $tmpl->Render();

?>