<?php define("_INSIDE",1);

require_once(realpath('./loader.inc.php'));
include_once(INC_PATH.'settings.inc.php');
include_once(INC_PATH.'functions.inc.php');
include_once(INC_PATH.'template.class.php');

$GLOBALS['_dnet']['act_time'] = gmdate("U") - 86400; // set after functions.php - otherwise getting logfile of 2 days ago!!!

// start the template system for output
$tmpl = new Template('rc5-72.yesterday.tpl');

$tmpl->setContent('title', $GLOBALS['_dnet']['lang']['teamstats'].' (RC5-72) '.$GLOBALS['_dnet']['lang']['yesterday']);

$team_data = DNETLog::getData('RC5-72', true);
if(!is_array($team_data) || count($team_data) <= 0) {
	$tmpl->setTemplate('error.tpl');
	$tmpl->setContent('error', $GLOBALS['_dnet']['lang']['nolog']);
	echo $tmpl->Render();
	exit();
}

$tmpl->setSubTemplate('UsersTableTemplate', 'clients.userstable.tpl');
$client_table_heads = array(
	'colNum' => '#',
	'colClient' => $GLOBALS['_dnet']['lang']['client'],
	'colPackages' => $GLOBALS['_dnet']['lang']['packages'],
	'colPart' => $GLOBALS['_dnet']['lang']['part'],
	'colBlocks' => $GLOBALS['_dnet']['lang']['blocks']
	);
$tmpl->setContent($client_table_heads);

$clients = array();
$nmbr = 0;
foreach($team_data['cl'] as $client=>$packages) {
	$packpart = ($packages['sum']['packages']*100/$team_data['sum']['packages']);
	$blockpart = ($packages['sum']['blocks']*100/$team_data['sum']['blocks']);
	$nmbr = $nmbr+1;

	$clients[] = array(
		'num' => $nmbr,
		'client' => emailCloaking($client, true, "client.yesterday.rc5-72.php"),
		'packages' => $packages['sum']['packages'],
		'packages_percentage' => number_format($packpart,2,',','.'),
		'packages_width_done' => round($packpart),
		'packages_width_todo' => (100-round($packpart)),
		'blocks' => $packages['sum']['blocks'],
		'blocks_percentage' => number_format($blockpart,2,',','.'),
		'blocks_width_done' => round($blockpart),
		'blocks_width_todo' => (100-round($blockpart))
		);
}
$tmpl->setContent('Clients', $clients);

$clients_contents = array(
	'Sum' => strtoupper($GLOBALS['_dnet']['lang']['sum']),
	'SumPackages' => $team_data['sum']['packages'],
	'SumPackages_percentage' => '100,00',
	'SumPackages_width_done' => '100',
	'SumBlocks' => $team_data['sum']['blocks'],
	'SumBlocks_percentage' => '100,00',
	'SumBlocks_width_done' => '100',
	);
$tmpl->setContent($clients_contents);

/*
# Static parameters for the prediction / forecast:
# 1) One package (block) = 4'294'967'296 Keys
#    => out of the dnet RC5-72 statistics
#      (all-over keys / all-over blocks = static value)
# 2) One GHz CPU-Power = ca. 5'200'000 Keys/second
#    => measured with the dnet-client programm
#      (6 GHz CPU = 27'000'000 Keys/second +/- 12% => 6 GHz = ca. 31'000'000 Keys/second)
*/
// get timestamp client sent the first package today
$cl_update = split(" ",$team_data['upd'][0]);
$cl_time = split(":",$cl_update[1]);
$day['active_start'] = gmmktime(intval($cl_time[0]),intval($cl_time[1]),intval($cl_time[2]),gmdate("m",$GLOBALS['_dnet']['act_time']),gmdate("d",$GLOBALS['_dnet']['act_time']),gmdate("Y",$GLOBALS['_dnet']['act_time']));
// get timestamp client sent the last package today
$cl_update = split(" ",$team_data['upd'][1]);
$cl_time = split(":",$cl_update[1]);
$day['active_end'] = gmmktime(intval($cl_time[0]),intval($cl_time[1]),intval($cl_time[2]),gmdate("m",$GLOBALS['_dnet']['act_time']),gmdate("d",$GLOBALS['_dnet']['act_time']),gmdate("Y",$GLOBALS['_dnet']['act_time']));
// time of client-activity
$day['active_seconds'] = ($day['active_end'] - $day['active_start']);
$day['active_hours'] = $day['active_seconds'] / 3600;
// get other timestamps
$day['start'] = gmmktime(0,0,0,gmdate("m",$GLOBALS['_dnet']['act_time']),gmdate("d",$GLOBALS['_dnet']['act_time']),gmdate("Y",$GLOBALS['_dnet']['act_time']));
$day['end'] = gmmktime(23,59,59,gmdate("m",$GLOBALS['_dnet']['act_time']),gmdate("d",$GLOBALS['_dnet']['act_time']),gmdate("Y",$GLOBALS['_dnet']['act_time']));
// get packages per hour of run-time
$stat['packrate'] = ($team_data['sum']['packages'] / $day['active_hours']);
$stat['blockrate'] = ($team_data['sum']['blocks'] / $day['active_hours']);
$stat['blockpackrate'] = ($team_data['sum']['blocks'] / $team_data['sum']['packages']);
// get keyrate per second
// => transform: packages/hour into keys/second
// 1 Block    1hour          4'294'967'296 Keys    1 Block    4'294'967'296 Keys
// -------- * ------------ * ------------------ => -------- = ------------- ------
// 1 hour     3600 seconds   1 Block               1 hour     3600          second
//
// this means a factor of: 4'294'967'296 / 3600 = 1193046,47111...
// index: million keys/second => 1193046,471 / 1000000 => Multiplier: 1.193
$stat['keyrate'] = ($stat['blockrate'] * 1.193);
// get estimated cpu-power
// => keyrate / Power of 1 GHz CPU-Power
// index of keyrate is million keys/s => Multiplier: 5.2
$stat['cpupower'] = ($stat['keyrate'] / 5.2);

$stats_contents = array(
	'titleStatistics' => $GLOBALS['_dnet']['lang']['statistics'],
	'starttime' => $GLOBALS['_dnet']['lang']['starttime'],
	'starttimeValue' => gmdate($GLOBALS['_dnet']['lang']['dateformat'],($day['start']+$GLOBALS['_dnet']['act_offset'])),
	'endtime' => $GLOBALS['_dnet']['lang']['endtime'],
	'endtimeValue' => gmdate($GLOBALS['_dnet']['lang']['dateformat'],($day['end']+$GLOBALS['_dnet']['act_offset'])),
	'first_package' => $GLOBALS['_dnet']['lang']['first_package'],
	'first_packageValue' => gmdate($GLOBALS['_dnet']['lang']['dateformat'],($day['active_start']+$GLOBALS['_dnet']['act_offset'])),
	'last_package' => $GLOBALS['_dnet']['lang']['last_package'],
	'last_packageValue' => gmdate($GLOBALS['_dnet']['lang']['dateformat'],($day['active_end']+$GLOBALS['_dnet']['act_offset'])),
	'worktime' => $GLOBALS['_dnet']['lang']['worktime'],
	'worktimeValue' => gmdate("H",$day['active_seconds']).' '.$GLOBALS['_dnet']['lang']['h'].' '.gmdate("i",$day['active_seconds']).' '.$GLOBALS['_dnet']['lang']['m'].' '.gmdate("s",$day['active_seconds']).' '.$GLOBALS['_dnet']['lang']['s'],
	'packrate' => $GLOBALS['_dnet']['lang']['packrate'],
	'packrateValue' => number_format($stat['packrate'],2,',','.').' '.$GLOBALS['_dnet']['lang']['packrateindex'],
	'blockpackrate' => $GLOBALS['_dnet']['lang']['blockpackrate'],
	'blockpackrateValue' => number_format($stat['blockpackrate'],2,',','.').' '.$GLOBALS['_dnet']['lang']['blockpackrateindex'],
	'blockrate' => $GLOBALS['_dnet']['lang']['blockrate'],
	'blockrateValue' => number_format($stat['blockrate'],2,',','.').' '.$GLOBALS['_dnet']['lang']['blockrateindex'],
	'keyrate' => $GLOBALS['_dnet']['lang']['keyrate'],
	'keyrateValue' => number_format($stat['keyrate'],2,',','.').' '.$GLOBALS['_dnet']['lang']['keyrateindex'],
	'cpupower' => $GLOBALS['_dnet']['lang']['cpupower'],
	'cpupowerValue' => number_format($stat['cpupower'],2,',','.').' GHz'
	);
$tmpl->setContent($stats_contents);

// Bar-Graph
$tmpl->setSubTemplate('GraphIframeTemplate', 'clients.graphs.iframe.tpl');
$bar_contents = array(
	'GraphTitle' => $GLOBALS['_dnet']['lang']['day_stats'],
	'frameName' => 'if_bar_graph',
	'frameClass' => 'iframe_bar_graph',
	'frameScrolling' => 'no',
	'GraphURL' => 'bar_graph.php?y=1&hl=1&prj=RC5-72&showlang='.$GLOBALS['_dnet']['web']['lang'],
	'GraphWidth' => ($GLOBALS['_dnet']['web']['day_stats_iframe']['width'] - $GLOBALS['_dnet']['bar_graph']['legend_width']),
	'GraphHeight' => ($GLOBALS['_dnet']['web']['day_stats_iframe']['height'] - $GLOBALS['_dnet']['web']['day_stats_iframe']['nav_height']),
	);
$tmpl->setContent($bar_contents);

echo $tmpl->Render();

?>